!******************************************************************************!
!                                                                              !
!    class_couplings.f90                                                       !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   class_couplings.f90                            |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 05/2018                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2018-10-04 15:46             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module class_couplings
  use constants_mdl
  use class_particles
  implicit none
  save
  integer, parameter :: n = 145

  logical :: couplings_init = .false.
  logical :: ctcouplings_init = .false.
  complex(dp) :: coupl(983)
  integer, parameter :: nGC_4532 = 1
  integer, parameter :: nGC_4507 = 2
  integer, parameter :: nGC_4469 = 3
  integer, parameter :: nGC_4505 = 4
  integer, parameter :: nGC_31 = 5
  integer, parameter :: nGC_4639 = 6
  integer, parameter :: nGC_4638 = 7
  integer, parameter :: nGC_4634 = 8
  integer, parameter :: nGC_4637 = 9
  integer, parameter :: nGC_4636 = 10
  integer, parameter :: nGC_4631 = 11
  integer, parameter :: nGC_4630 = 12
  integer, parameter :: nGC_4632 = 13
  integer, parameter :: nGC_4414 = 14
  integer, parameter :: nGC_4417 = 15
  integer, parameter :: nGC_4416 = 16
  integer, parameter :: nGC_4411 = 17
  integer, parameter :: nGC_4410 = 18
  integer, parameter :: nGC_4413 = 19
  integer, parameter :: nGC_4412 = 20
  integer, parameter :: nGC_4419 = 21
  integer, parameter :: nGC_4418 = 22
  integer, parameter :: nGC_4384 = 23
  integer, parameter :: nGC_4387 = 24
  integer, parameter :: nGC_4386 = 25
  integer, parameter :: nGC_4380 = 26
  integer, parameter :: nGC_4382 = 27
  integer, parameter :: nGC_4388 = 28
  integer, parameter :: nGC_32 = 29
  integer, parameter :: nGC_35 = 30
  integer, parameter :: nGC_MZ_GF = 31
  integer, parameter :: nGC_99 = 32
  integer, parameter :: nGC_98 = 33
  integer, parameter :: nGC_102 = 34
  integer, parameter :: nGC_4560 = 35
  integer, parameter :: nGC_28 = 36
  integer, parameter :: nGC_29 = 37
  integer, parameter :: nGC_4564 = 38
  integer, parameter :: nGC_4566 = 39
  integer, parameter :: nGC_23 = 40
  integer, parameter :: nGC_20 = 41
  integer, parameter :: nGC_21 = 42
  integer, parameter :: nGC_26 = 43
  integer, parameter :: nGC_27 = 44
  integer, parameter :: nGC_24 = 45
  integer, parameter :: nGC_25 = 46
  integer, parameter :: nGC_34 = 47
  integer, parameter :: nGC_93 = 48
  integer, parameter :: nGC_103 = 49
  integer, parameter :: nGC_14 = 50
  integer, parameter :: nGC_37 = 51
  integer, parameter :: nGC_4509 = 52
  integer, parameter :: nGC_82 = 53
  integer, parameter :: nGC_36 = 54
  integer, parameter :: nGC_80 = 55
  integer, parameter :: nGC_126 = 56
  integer, parameter :: nGC_124 = 57
  integer, parameter :: nGC_125 = 58
  integer, parameter :: nGC_122 = 59
  integer, parameter :: nGC_123 = 60
  integer, parameter :: nGC_120 = 61
  integer, parameter :: nGC_121 = 62
  integer, parameter :: nGC_MMW_GF = 63
  integer, parameter :: nGC_75 = 64
  integer, parameter :: nGC_74 = 65
  integer, parameter :: nGC_77 = 66
  integer, parameter :: nGC_76 = 67
  integer, parameter :: nGC_9108 = 68
  integer, parameter :: nGC_70 = 69
  integer, parameter :: nGC_4558 = 70
  integer, parameter :: nGC_73 = 71
  integer, parameter :: nGC_71 = 72
  integer, parameter :: nGC_4349 = 73
  integer, parameter :: nGC_4348 = 74
  integer, parameter :: nGC_4340 = 75
  integer, parameter :: nGC_4342 = 76
  integer, parameter :: nGC_4345 = 77
  integer, parameter :: nGC_4344 = 78
  integer, parameter :: nGC_114 = 79
  integer, parameter :: nGC_4346 = 80
  integer, parameter :: nGC_4525 = 81
  integer, parameter :: nGC_4527 = 82
  integer, parameter :: nGC_4526 = 83
  integer, parameter :: nGC_4523 = 84
  integer, parameter :: nGC_4522 = 85
  integer, parameter :: nGC_4528 = 86
  integer, parameter :: nGC_4449 = 87
  integer, parameter :: nGC_4446 = 88
  integer, parameter :: nGC_4447 = 89
  integer, parameter :: nGC_4444 = 90
  integer, parameter :: nGC_4445 = 91
  integer, parameter :: nGC_4442 = 92
  integer, parameter :: nGC_4443 = 93
  integer, parameter :: nGC_4441 = 94
  integer, parameter :: nGC_3 = 95
  integer, parameter :: nGC_2 = 96
  integer, parameter :: nGC_1 = 97
  integer, parameter :: nGC_6 = 98
  integer, parameter :: nGC_5 = 99
  integer, parameter :: nGC_4 = 100
  integer, parameter :: nGC_9 = 101
  integer, parameter :: nGC_8 = 102
  integer, parameter :: nGC_4590 = 103
  integer, parameter :: nGC_4591 = 104
  integer, parameter :: nGC_4592 = 105
  integer, parameter :: nGC_4593 = 106
  integer, parameter :: nGC_4594 = 107
  integer, parameter :: nGC_4595 = 108
  integer, parameter :: nGC_4596 = 109
  integer, parameter :: nGC_4597 = 110
  integer, parameter :: nGC_4598 = 111
  integer, parameter :: nGC_64 = 112
  integer, parameter :: nGC_16 = 113
  integer, parameter :: nGC_4540 = 114
  integer, parameter :: nGC_15 = 115
  integer, parameter :: nGC_1623 = 116
  integer, parameter :: nGC_53 = 117
  integer, parameter :: nGC_52 = 118
  integer, parameter :: nGC_51 = 119
  integer, parameter :: nGC_50 = 120
  integer, parameter :: nGC_57 = 121
  integer, parameter :: nGC_56 = 122
  integer, parameter :: nGC_55 = 123
  integer, parameter :: nGC_54 = 124
  integer, parameter :: nGC_13 = 125
  integer, parameter :: nGC_59 = 126
  integer, parameter :: nGC_58 = 127
  integer, parameter :: nGC_46 = 128
  integer, parameter :: nGC_12 = 129
  integer, parameter :: nGC_47 = 130
  integer, parameter :: nGC_11 = 131
  integer, parameter :: nGC_101 = 132
  integer, parameter :: nGC_40 = 133
  integer, parameter :: nGC_10 = 134
  integer, parameter :: nGC_6654 = 135
  integer, parameter :: nGC_41 = 136
  integer, parameter :: nGC_MC = 137
  integer, parameter :: nGC_2065 = 138
  integer, parameter :: nGC_104 = 139
  integer, parameter :: nGC_49 = 140
  integer, parameter :: nGC_7324 = 141
  integer, parameter :: nGC_7325 = 142
  integer, parameter :: nGC_4520 = 143
  integer, parameter :: nGC_4572 = 144
  integer, parameter :: nGC_8240 = 145
  integer, parameter :: nGC_4628 = 146
  integer, parameter :: nGC_4622 = 147
  integer, parameter :: nGC_4621 = 148
  integer, parameter :: nGC_4627 = 149
  integer, parameter :: nGC_4624 = 150
  integer, parameter :: nGC_4625 = 151
  integer, parameter :: nGC_4403 = 152
  integer, parameter :: nGC_4400 = 153
  integer, parameter :: nGC_4401 = 154
  integer, parameter :: nGC_4406 = 155
  integer, parameter :: nGC_4407 = 156
  integer, parameter :: nGC_4404 = 157
  integer, parameter :: nGC_4405 = 158
  integer, parameter :: nGC_4529 = 159
  integer, parameter :: nGC_4408 = 160
  integer, parameter :: nGC_4409 = 161
  integer, parameter :: nGC_397 = 162
  integer, parameter :: nGC_4390 = 163
  integer, parameter :: nGC_4391 = 164
  integer, parameter :: nGC_4397 = 165
  integer, parameter :: nGC_4394 = 166
  integer, parameter :: nGC_4395 = 167
  integer, parameter :: nGC_4398 = 168
  integer, parameter :: nGC_I = 169
  integer, parameter :: nGC_7216 = 170
  integer, parameter :: nGC_7217 = 171
  integer, parameter :: nGC_4499 = 172
  integer, parameter :: nGC_4498 = 173
  integer, parameter :: nGC_4496 = 174
  integer, parameter :: nGC_4490 = 175
  integer, parameter :: nGC_4493 = 176
  integer, parameter :: nGC_4492 = 177
  integer, parameter :: nGC_17 = 178
  integer, parameter :: nGC_4274 = 179
  integer, parameter :: nGC_4277 = 180
  integer, parameter :: nGC_4270 = 181
  integer, parameter :: nGC_4273 = 182
  integer, parameter :: nGC_4272 = 183
  integer, parameter :: nGC_19 = 184
  integer, parameter :: nGC_18 = 185
  integer, parameter :: nGC_4477 = 186
  integer, parameter :: nGC_4475 = 187
  integer, parameter :: nGC_4472 = 188
  integer, parameter :: nGC_4578 = 189
  integer, parameter :: nGC_4470 = 190
  integer, parameter :: nGC_4576 = 191
  integer, parameter :: nGC_4574 = 192
  integer, parameter :: nGC_4575 = 193
  integer, parameter :: nGC_6611 = 194
  integer, parameter :: nGC_4573 = 195
  integer, parameter :: nGC_4570 = 196
  integer, parameter :: nGC_4571 = 197
  integer, parameter :: nGC_62 = 198
  integer, parameter :: nGC_415 = 199
  integer, parameter :: nGC_7269 = 200
  integer, parameter :: nGC_637 = 201
  integer, parameter :: nGC_631 = 202
  integer, parameter :: nGC_MTA = 203
  integer, parameter :: nGC_7 = 204
  integer, parameter :: nGC_6688 = 205
  integer, parameter :: nGC_8105 = 206
  integer, parameter :: nGC_95 = 207
  integer, parameter :: nGC_7401 = 208
  integer, parameter :: nGC_7400 = 209
  integer, parameter :: nGC_4454 = 210
  integer, parameter :: nGC_6951 = 211
  integer, parameter :: nGC_4356 = 212
  integer, parameter :: nGC_4357 = 213
  integer, parameter :: nGC_4354 = 214
  integer, parameter :: nGC_4355 = 215
  integer, parameter :: nGC_4350 = 216
  integer, parameter :: nGC_4358 = 217
  integer, parameter :: nGC_4359 = 218
  integer, parameter :: nGC_4599 = 219
  integer, parameter :: nGC_221 = 220
  integer, parameter :: nGC_6612 = 221
  integer, parameter :: nGC_6383 = 222
  integer, parameter :: nGC_4613 = 223
  integer, parameter :: nGC_4611 = 224
  integer, parameter :: nGC_4616 = 225
  integer, parameter :: nGC_4615 = 226
  integer, parameter :: nGC_4614 = 227
  integer, parameter :: nGC_4378 = 228
  integer, parameter :: nGC_4619 = 229
  integer, parameter :: nGC_4618 = 230
  integer, parameter :: nGC_7677 = 231
  integer, parameter :: nGC_7696 = 232
  integer, parameter :: nGC_4533 = 233
  integer, parameter :: nGC_4530 = 234
  integer, parameter :: nGC_4531 = 235
  integer, parameter :: nGC_4536 = 236
  integer, parameter :: nGC_4537 = 237
  integer, parameter :: nGC_4534 = 238
  integer, parameter :: nGC_4535 = 239
  integer, parameter :: nGC_4538 = 240
  integer, parameter :: nGC_4539 = 241
  integer, parameter :: nGC_4439 = 242
  integer, parameter :: nGC_4433 = 243
  integer, parameter :: nGC_4430 = 244
  integer, parameter :: nGC_4437 = 245
  integer, parameter :: nGC_4436 = 246
  integer, parameter :: nGC_4435 = 247
  integer, parameter :: nGC_4370 = 248
  integer, parameter :: nGC_7384 = 249
  integer, parameter :: nGC_359 = 250
  integer, parameter :: nGC_4275 = 251
  integer, parameter :: nGC_4546 = 252
  integer, parameter :: nGC_4544 = 253
  integer, parameter :: nGC_4542 = 254
  integer, parameter :: nGC_4226 = 255
  integer, parameter :: nGC_45 = 256
  integer, parameter :: nGC_4224 = 257
  integer, parameter :: nGC_4225 = 258
  integer, parameter :: nGC_4223 = 259
  integer, parameter :: nGC_42 = 260
  integer, parameter :: nGC_43 = 261
  integer, parameter :: nGC_7745 = 262
  integer, parameter :: nGC_179 = 263
  integer, parameter :: nGC_4471 = 264
  integer, parameter :: nGC_7133 = 265
  integer, parameter :: nGC_9097 = 266
  integer, parameter :: nGC_7130 = 267
  integer, parameter :: nGC_4234 = 268
  integer, parameter :: nGC_6705 = 269
  integer, parameter :: nGC_4548 = 270
  integer, parameter :: nGC_6961 = 271
  integer, parameter :: nGC_4644 = 272
  integer, parameter :: nGC_4645 = 273
  integer, parameter :: nGC_4646 = 274
  integer, parameter :: nGC_4648 = 275
  integer, parameter :: nGC_4640 = 276
  integer, parameter :: nGC_4647 = 277
  integer, parameter :: nGC_4641 = 278
  integer, parameter :: nGC_4232 = 279
  integer, parameter :: nGC_4642 = 280
  integer, parameter :: nGC_4643 = 281
  integer, parameter :: nGC_44 = 282
  integer, parameter :: nGC_6620 = 283
  integer, parameter :: nGC_7596 = 284
  integer, parameter :: nGC_4249 = 285
  integer, parameter :: nGC_4235 = 286
  integer, parameter :: nGC_4562 = 287
  integer, parameter :: nGC_215 = 288
  integer, parameter :: nGC_4240 = 289
  integer, parameter :: nGC_6541 = 290
  integer, parameter :: nGC_6540 = 291
  integer, parameter :: nGC_4369 = 292
  integer, parameter :: nGC_4568 = 293
  integer, parameter :: nGC_4367 = 294
  integer, parameter :: nGC_4366 = 295
  integer, parameter :: nGC_4365 = 296
  integer, parameter :: nGC_4363 = 297
  integer, parameter :: nGC_4360 = 298
  integer, parameter :: nGC_7134 = 299
  integer, parameter :: nGC_4588 = 300
  integer, parameter :: nGC_4488 = 301
  integer, parameter :: nGC_4489 = 302
  integer, parameter :: nGC_6623 = 303
  integer, parameter :: nGC_4482 = 304
  integer, parameter :: nGC_4483 = 305
  integer, parameter :: nGC_4480 = 306
  integer, parameter :: nGC_4486 = 307
  integer, parameter :: nGC_4487 = 308
  integer, parameter :: nGC_4484 = 309
  integer, parameter :: nGC_4485 = 310
  integer, parameter :: nGC_4263 = 311
  integer, parameter :: nGC_4260 = 312
  integer, parameter :: nGC_4266 = 313
  integer, parameter :: nGC_4267 = 314
  integer, parameter :: nGC_4264 = 315
  integer, parameter :: nGC_4265 = 316
  integer, parameter :: nGC_4268 = 317
  integer, parameter :: nGC_4269 = 318
  integer, parameter :: nGC_4466 = 319
  integer, parameter :: nGC_4508 = 320
  integer, parameter :: nGC_4460 = 321
  integer, parameter :: nGC_4461 = 322
  integer, parameter :: nGC_4462 = 323
  integer, parameter :: nGC_4463 = 324
  integer, parameter :: nGC_6602 = 325
  integer, parameter :: nGC_6603 = 326
  integer, parameter :: nGC_4501 = 327
  integer, parameter :: nGC_4468 = 328
  integer, parameter :: nGC_6604 = 329
  integer, parameter :: nGC_4504 = 330
  integer, parameter :: nGC_4479 = 331
  integer, parameter :: nGC_4559 = 332
  integer, parameter :: nGC_4519 = 333
  integer, parameter :: nGC_593 = 334
  integer, parameter :: nGC_97 = 335
  integer, parameter :: nGC_96 = 336
  integer, parameter :: nGC_7171 = 337
  integer, parameter :: nGC_94 = 338
  integer, parameter :: nGC_92 = 339
  integer, parameter :: nGC_91 = 340
  integer, parameter :: nGC_90 = 341
  integer, parameter :: nGC_4478 = 342
  integer, parameter :: nGC_6920 = 343
  integer, parameter :: nGC_4456 = 344
  integer, parameter :: nGC_4217 = 345
  integer, parameter :: nGC_4216 = 346
  integer, parameter :: nGC_4212 = 347
  integer, parameter :: nGC_4210 = 348
  integer, parameter :: nGC_79 = 349
  integer, parameter :: nGC_78 = 350
  integer, parameter :: nGC_4219 = 351
  integer, parameter :: nGC_4218 = 352
  integer, parameter :: nGC_4187 = 353
  integer, parameter :: nGC_4185 = 354
  integer, parameter :: nGC_4189 = 355
  integer, parameter :: nGC_4188 = 356
  integer, parameter :: nGC_100 = 357
  integer, parameter :: nGC_7004 = 358
  integer, parameter :: nGC_7003 = 359
  integer, parameter :: nGC_105 = 360
  integer, parameter :: nGC_106 = 361
  integer, parameter :: nGC_107 = 362
  integer, parameter :: nGC_108 = 363
  integer, parameter :: nGC_109 = 364
  integer, parameter :: nGC_6372 = 365
  integer, parameter :: nGC_8239 = 366
  integer, parameter :: nGC_22 = 367
  integer, parameter :: nGC_6788 = 368
  integer, parameter :: nGC_4541 = 369
  integer, parameter :: nGC_60 = 370
  integer, parameter :: nGC_6780 = 371
  integer, parameter :: nGC_MWp = 372
  integer, parameter :: nGC_4321 = 373
  integer, parameter :: nGC_4320 = 374
  integer, parameter :: nGC_4327 = 375
  integer, parameter :: nGC_4324 = 376
  integer, parameter :: nGC_6423 = 377
  integer, parameter :: nGC_6425 = 378
  integer, parameter :: nGC_6428 = 379
  integer, parameter :: nGC_6587 = 380
  integer, parameter :: nGC_88 = 381
  integer, parameter :: nGC_89 = 382
  integer, parameter :: nGC_211 = 383
  integer, parameter :: nGC_6393 = 384
  integer, parameter :: nGC_4600 = 385
  integer, parameter :: nGC_4601 = 386
  integer, parameter :: nGC_4602 = 387
  integer, parameter :: nGC_4603 = 388
  integer, parameter :: nGC_4607 = 389
  integer, parameter :: nGC_4608 = 390
  integer, parameter :: nGC_4609 = 391
  integer, parameter :: nGC_4241 = 392
  integer, parameter :: nGC_4586 = 393
  integer, parameter :: nGC_7173 = 394
  integer, parameter :: nGC_6732 = 395
  integer, parameter :: nGC_4428 = 396
  integer, parameter :: nGC_4429 = 397
  integer, parameter :: nGC_6637 = 398
  integer, parameter :: nGC_929 = 399
  integer, parameter :: nGC_4420 = 400
  integer, parameter :: nGC_4421 = 401
  integer, parameter :: nGC_4422 = 402
  integer, parameter :: nGC_4423 = 403
  integer, parameter :: nGC_4424 = 404
  integer, parameter :: nGC_4425 = 405
  integer, parameter :: nGC_4426 = 406
  integer, parameter :: nGC_4427 = 407
  integer, parameter :: nGC_4502 = 408
  integer, parameter :: nGC_6518 = 409
  integer, parameter :: nGC_6544 = 410
  integer, parameter :: nGC_84 = 411
  integer, parameter :: nGC_4243 = 412
  integer, parameter :: nGC_361 = 413
  integer, parameter :: nGC_7232 = 414
  integer, parameter :: nGC_7233 = 415
  integer, parameter :: nGC_8392 = 416
  integer, parameter :: nGC_8393 = 417
  integer, parameter :: nGC_4368 = 418
  integer, parameter :: nGC_39 = 419
  integer, parameter :: nGC_4556 = 420
  integer, parameter :: nGC_4557 = 421
  integer, parameter :: nGC_4244 = 422
  integer, parameter :: nGC_4552 = 423
  integer, parameter :: nGC_4553 = 424
  integer, parameter :: nGC_4253 = 425
  integer, parameter :: nGC_4250 = 426
  integer, parameter :: nGC_4256 = 427
  integer, parameter :: nGC_4254 = 428
  integer, parameter :: nGC_4362 = 429
  integer, parameter :: nGC_4245 = 430
  integer, parameter :: nGC_6671 = 431
  integer, parameter :: nGC_7128 = 432
  integer, parameter :: nGC_6979 = 433
  integer, parameter :: nGC_6976 = 434
  integer, parameter :: nGC_7172 = 435
  integer, parameter :: nGC_MT = 436
  integer, parameter :: nGC_66 = 437
  integer, parameter :: nGC_4227 = 438
  integer, parameter :: nGC_6745 = 439
  integer, parameter :: nGC_65 = 440
  integer, parameter :: nGC_6707 = 441
  integer, parameter :: nGC_72 = 442
  integer, parameter :: nGC_4201 = 443
  integer, parameter :: nGC_MI = 444
  integer, parameter :: nGC_MH = 445
  integer, parameter :: nGC_6433 = 446
  integer, parameter :: nGC_MM = 447
  integer, parameter :: nGC_869 = 448
  integer, parameter :: nGC_MB = 449
  integer, parameter :: nGC_61 = 450
  integer, parameter :: nGC_8053 = 451
  integer, parameter :: nGC_ME = 452
  integer, parameter :: nGC_MD = 453
  integer, parameter :: nGC_MZ = 454
  integer, parameter :: nGC_MS = 455
  integer, parameter :: nGC_MW = 456
  integer, parameter :: nGC_MU = 457
  integer, parameter :: nGC_48 = 458
  integer, parameter :: nGC_9113 = 459
  integer, parameter :: nGC_63 = 460
  integer, parameter :: nGC_6940 = 461
  integer, parameter :: nGC_MW_GF = 462
  integer, parameter :: nGC_4301 = 463
  integer, parameter :: nGC_4510 = 464
  integer, parameter :: nGC_6807 = 465
  integer, parameter :: nGC_4379 = 466
  integer, parameter :: nGC_4375 = 467
  integer, parameter :: nGC_4376 = 468
  integer, parameter :: nGC_4302 = 469
  integer, parameter :: nGC_6808 = 470
  integer, parameter :: nGC_4371 = 471
  integer, parameter :: nGC_4372 = 472
  integer, parameter :: nGC_4373 = 473
  integer, parameter :: nGC_4554 = 474
  integer, parameter :: nGC_243 = 475
  integer, parameter :: nGC_4555 = 476
  integer, parameter :: nGC_7606 = 477
  integer, parameter :: nGC_6417 = 478
  integer, parameter :: nGC_6631 = 479
  integer, parameter :: nGC_4258 = 480
  integer, parameter :: nGC_6386 = 481
  integer, parameter :: nGC_38 = 482
  integer, parameter :: nGC_4550 = 483
  integer, parameter :: nGC_4259 = 484
  integer, parameter :: nGC_4299 = 485
  integer, parameter :: nGC_4298 = 486
  integer, parameter :: nGC_4297 = 487
  integer, parameter :: nGC_4296 = 488
  integer, parameter :: nGC_4295 = 489
  integer, parameter :: nGC_4294 = 490
  integer, parameter :: nGC_4293 = 491
  integer, parameter :: nGC_4292 = 492
  integer, parameter :: nGC_4291 = 493
  integer, parameter :: nGC_4290 = 494
  integer, parameter :: nGC_4451 = 495
  integer, parameter :: nGC_4450 = 496
  integer, parameter :: nGC_4453 = 497
  integer, parameter :: nGC_4452 = 498
  integer, parameter :: nGC_4455 = 499
  integer, parameter :: nGC_4186 = 500
  integer, parameter :: nGC_4457 = 501
  integer, parameter :: nGC_30 = 502
  integer, parameter :: nGC_4459 = 503
  integer, parameter :: nGC_4511 = 504
  integer, parameter :: nGC_4512 = 505
  integer, parameter :: nGC_4513 = 506
  integer, parameter :: nGC_4514 = 507
  integer, parameter :: nGC_33 = 508
  integer, parameter :: nGC_4516 = 509
  integer, parameter :: nGC_4517 = 510
  integer, parameter :: nGC_6527 = 511
  integer, parameter :: nGC_6523 = 512
  integer, parameter :: nGC_7256 = 513
  integer, parameter :: nGC_7088 = 514
  integer, parameter :: nGC_183 = 515
  integer, parameter :: nGC_7082 = 516
  integer, parameter :: nGC_187 = 517
  integer, parameter :: nGC_4582 = 518
  integer, parameter :: nGC_4580 = 519
  integer, parameter :: nGC_4587 = 520
  integer, parameter :: nGC_7244 = 521
  integer, parameter :: nGC_7247 = 522
  integer, parameter :: nGC_4584 = 523
  integer, parameter :: nGC_81 = 524
  integer, parameter :: nGC_7162 = 525
  integer, parameter :: nGC_83 = 526
  integer, parameter :: nGC_7164 = 527
  integer, parameter :: nGC_85 = 528
  integer, parameter :: nGC_86 = 529
  integer, parameter :: nGC_87 = 530
  integer, parameter :: nGC_4334 = 531
  integer, parameter :: nGC_145 = 532
  integer, parameter :: nGC_6938 = 533
  integer, parameter :: nGC_6939 = 534
  integer, parameter :: nGC_4204 = 535
  integer, parameter :: nGC_67 = 536
  integer, parameter :: nGC_4206 = 537
  integer, parameter :: nGC_4207 = 538
  integer, parameter :: nGC_4200 = 539
  integer, parameter :: nGC_4202 = 540
  integer, parameter :: nGC_4203 = 541
  integer, parameter :: nGC_4208 = 542
  integer, parameter :: nGC_4209 = 543
  integer, parameter :: nGC_68 = 544
  integer, parameter :: nGC_69 = 545
  integer, parameter :: nGC_4194 = 546
  integer, parameter :: nGC_4195 = 547
  integer, parameter :: nGC_4196 = 548
  integer, parameter :: nGC_4197 = 549
  integer, parameter :: nGC_4190 = 550
  integer, parameter :: nGC_4191 = 551
  integer, parameter :: nGC_4192 = 552
  integer, parameter :: nGC_4193 = 553
  integer, parameter :: nGC_4515 = 554
  integer, parameter :: nGC_4198 = 555
  integer, parameter :: nGC_4199 = 556
  integer, parameter :: nGC_4205 = 557
  integer, parameter :: nGC_4458 = 558
  integer, parameter :: nGC_4467 = 559
  integer, parameter :: nGC_119 = 560
  integer, parameter :: nGC_118 = 561
  integer, parameter :: nGC_117 = 562
  integer, parameter :: nGC_116 = 563
  integer, parameter :: nGC_115 = 564
  integer, parameter :: nGC_6470 = 565
  integer, parameter :: nGC_113 = 566
  integer, parameter :: nGC_112 = 567
  integer, parameter :: nGC_111 = 568
  integer, parameter :: nGC_110 = 569
  integer, parameter :: nGC_6986 = 570
  integer, parameter :: nGC_6981 = 571
  integer, parameter :: nGC_6982 = 572
  integer, parameter :: nGC_7425 = 573
  integer, parameter :: nGC_4337 = 574
  integer, parameter :: nGC_7426 = 575
  integer, parameter :: nGC_6601 = 576
  integer, parameter :: nGC_6791 = 577
  integer, parameter :: nGC_6793 = 578
  integer, parameter :: nGC_6794 = 579
  integer, parameter :: nGC_4332 = 580
  integer, parameter :: nGC_6592 = 581
  integer, parameter :: nGC_7868 = 582
  integer, parameter :: nGC_4336 = 583
  integer, parameter :: nGC_7865 = 584
  integer, parameter :: nGC_4339 = 585
  integer, parameter :: nGC_7861 = 586
  integer, parameter :: nGC_7860 = 587
  integer, parameter :: nGC_6849 = 588
  integer, parameter :: nGC_6846 = 589
  integer, parameter :: nGC_8251 = 590
  integer, parameter :: nGC_4415 = 591
  integer, parameter :: nGC_8955 = 592
  integer, parameter :: nGC_381 = 593
  integer, parameter :: nGC_8952 = 594
  integer, parameter :: nGC_8953 = 595
  integer, parameter :: nGC_4385 = 596
  integer, parameter :: nGC_4381 = 597
  integer, parameter :: nGC_4383 = 598
  integer, parameter :: nGC_4389 = 599
  integer, parameter :: nGC_6446 = 600
  integer, parameter :: nGC_6441 = 601
  integer, parameter :: nGC_371 = 602
  integer, parameter :: nGC_6449 = 603
  integer, parameter :: nGC_6564 = 604
  integer, parameter :: nGC_7271 = 605
  integer, parameter :: nGC_4561 = 606
  integer, parameter :: nGC_4563 = 607
  integer, parameter :: nGC_4565 = 608
  integer, parameter :: nGC_4569 = 609
  integer, parameter :: nGC_4242 = 610
  integer, parameter :: nGC_4246 = 611
  integer, parameter :: nGC_4247 = 612
  integer, parameter :: nGC_7113 = 613
  integer, parameter :: nGC_7114 = 614
  integer, parameter :: nGC_7057 = 615
  integer, parameter :: nGC_6941 = 616
  integer, parameter :: nGC_7804 = 617
  integer, parameter :: nGC_6756 = 618
  integer, parameter :: nGC_6757 = 619
  integer, parameter :: nGC_791 = 620
  integer, parameter :: nGC_6490 = 621
  integer, parameter :: nGC_6497 = 622
  integer, parameter :: nGC_6498 = 623
  integer, parameter :: nGC_7210 = 624
  integer, parameter :: nGC_6882 = 625
  integer, parameter :: nGC_6883 = 626
  integer, parameter :: nGC_305 = 627
  integer, parameter :: nGC_7191 = 628
  integer, parameter :: nGC_9100 = 629
  integer, parameter :: nGC_6772 = 630
  integer, parameter :: nGC_7837 = 631
  integer, parameter :: nGC_4333 = 632
  integer, parameter :: nGC_4341 = 633
  integer, parameter :: nGC_4343 = 634
  integer, parameter :: nGC_4347 = 635
  integer, parameter :: nGC_4335 = 636
  integer, parameter :: nGC_6408 = 637
  integer, parameter :: nGC_6373 = 638
  integer, parameter :: nGC_6377 = 639
  integer, parameter :: nGC_6378 = 640
  integer, parameter :: nGC_6379 = 641
  integer, parameter :: nGC_6405 = 642
  integer, parameter :: nGC_4338 = 643
  integer, parameter :: nGC_4524 = 644
  integer, parameter :: nGC_4521 = 645
  integer, parameter :: nGC_4289 = 646
  integer, parameter :: nGC_4284 = 647
  integer, parameter :: nGC_4285 = 648
  integer, parameter :: nGC_4286 = 649
  integer, parameter :: nGC_4287 = 650
  integer, parameter :: nGC_4280 = 651
  integer, parameter :: nGC_4281 = 652
  integer, parameter :: nGC_4282 = 653
  integer, parameter :: nGC_4283 = 654
  integer, parameter :: nGC_4448 = 655
  integer, parameter :: nGC_4440 = 656
  integer, parameter :: nGC_7095 = 657
  integer, parameter :: nGC_7091 = 658
  integer, parameter :: nGC_7092 = 659
  integer, parameter :: nGC_7250 = 660
  integer, parameter :: nGC_567 = 661
  integer, parameter :: nGC_6909 = 662
  integer, parameter :: nGC_6908 = 663
  integer, parameter :: nGC_6907 = 664
  integer, parameter :: nGC_6710 = 665
  integer, parameter :: nGC_6711 = 666
  integer, parameter :: nGC_4233 = 667
  integer, parameter :: nGC_6713 = 668
  integer, parameter :: nGC_6714 = 669
  integer, parameter :: nGC_4237 = 670
  integer, parameter :: nGC_4239 = 671
  integer, parameter :: nGC_6651 = 672
  integer, parameter :: nGC_513 = 673
  integer, parameter :: nGC_4228 = 674
  integer, parameter :: nGC_4220 = 675
  integer, parameter :: nGC_10157 = 676
  integer, parameter :: nGC_7437 = 677
  integer, parameter :: nGC_2241 = 678
  integer, parameter :: nGC_6875 = 679
  integer, parameter :: nGC_7879 = 680
  integer, parameter :: nGC_4309 = 681
  integer, parameter :: nGC_6870 = 682
  integer, parameter :: nGC_4305 = 683
  integer, parameter :: nGC_4304 = 684
  integer, parameter :: nGC_7979 = 685
  integer, parameter :: nGC_4306 = 686
  integer, parameter :: nGC_7876 = 687
  integer, parameter :: nGC_4300 = 688
  integer, parameter :: nGC_4303 = 689
  integer, parameter :: nGC_4650 = 690
  integer, parameter :: nGC_8363 = 691
  integer, parameter :: nGC_8364 = 692
  integer, parameter :: nGC_4288 = 693
  integer, parameter :: nGC_6869 = 694
  integer, parameter :: nGC_7280 = 695
  integer, parameter :: nGC_8248 = 696
  integer, parameter :: nGC_4629 = 697
  integer, parameter :: nGC_4623 = 698
  integer, parameter :: nGC_4620 = 699
  integer, parameter :: nGC_4626 = 700
  integer, parameter :: nGC_4402 = 701
  integer, parameter :: nGC_4392 = 702
  integer, parameter :: nGC_4393 = 703
  integer, parameter :: nGC_4396 = 704
  integer, parameter :: nGC_7805 = 705
  integer, parameter :: nGC_4399 = 706
  integer, parameter :: nGC_7803 = 707
  integer, parameter :: nGC_7802 = 708
  integer, parameter :: nGC_7213 = 709
  integer, parameter :: nGC_7211 = 710
  integer, parameter :: nGC_7214 = 711
  integer, parameter :: nGC_6479 = 712
  integer, parameter :: nGC_6571 = 713
  integer, parameter :: nGC_1255 = 714
  integer, parameter :: nGC_6576 = 715
  integer, parameter :: nGC_8769 = 716
  integer, parameter :: nGC_4494 = 717
  integer, parameter :: nGC_4497 = 718
  integer, parameter :: nGC_4491 = 719
  integer, parameter :: nGC_4276 = 720
  integer, parameter :: nGC_4271 = 721
  integer, parameter :: nGC_4279 = 722
  integer, parameter :: nGC_4278 = 723
  integer, parameter :: nGC_4476 = 724
  integer, parameter :: nGC_4474 = 725
  integer, parameter :: nGC_4473 = 726
  integer, parameter :: nGC_4579 = 727
  integer, parameter :: nGC_7062 = 728
  integer, parameter :: nGC_8107 = 729
  integer, parameter :: nGC_8106 = 730
  integer, parameter :: nGC_8104 = 731
  integer, parameter :: nGC_6530 = 732
  integer, parameter :: nGC_6769 = 733
  integer, parameter :: nGC_6687 = 734
  integer, parameter :: nGC_6685 = 735
  integer, parameter :: nGC_6761 = 736
  integer, parameter :: nGC_6762 = 737
  integer, parameter :: nGC_6766 = 738
  integer, parameter :: nGC_6482 = 739
  integer, parameter :: nGC_6489 = 740
  integer, parameter :: nGC_6539 = 741
  integer, parameter :: nGC_6434 = 742
  integer, parameter :: nGC_6437 = 743
  integer, parameter :: nGC_6436 = 744
  integer, parameter :: nGC_6431 = 745
  integer, parameter :: nGC_6828 = 746
  integer, parameter :: nGC_6389 = 747
  integer, parameter :: nGC_6388 = 748
  integer, parameter :: nGC_6381 = 749
  integer, parameter :: nGC_6380 = 750
  integer, parameter :: nGC_4612 = 751
  integer, parameter :: nGC_4610 = 752
  integer, parameter :: nGC_4617 = 753
  integer, parameter :: nGC_6803 = 754
  integer, parameter :: nGC_4438 = 755
  integer, parameter :: nGC_4432 = 756
  integer, parameter :: nGC_4431 = 757
  integer, parameter :: nGC_4434 = 758
  integer, parameter :: nGC_6500 = 759
  integer, parameter :: nGC_6503 = 760
  integer, parameter :: nGC_6506 = 761
  integer, parameter :: nGC_6509 = 762
  integer, parameter :: nGC_7385 = 763
  integer, parameter :: nGC_7386 = 764
  integer, parameter :: nGC_6682 = 765
  integer, parameter :: nGC_6919 = 766
  integer, parameter :: nGC_6910 = 767
  integer, parameter :: nGC_4577 = 768
  integer, parameter :: nGC_4547 = 769
  integer, parameter :: nGC_4545 = 770
  integer, parameter :: nGC_4543 = 771
  integer, parameter :: nGC_6640 = 772
  integer, parameter :: nGC_4229 = 773
  integer, parameter :: nGC_4222 = 774
  integer, parameter :: nGC_4549 = 775
  integer, parameter :: nGC_4221 = 776
  integer, parameter :: nGC_4231 = 777
  integer, parameter :: nGC_4230 = 778
  integer, parameter :: nGC_9317 = 779
  integer, parameter :: nGC_6861 = 780
  integer, parameter :: nGC_6964 = 781
  integer, parameter :: nGC_4318 = 782
  integer, parameter :: nGC_4319 = 783
  integer, parameter :: nGC_4649 = 784
  integer, parameter :: nGC_4312 = 785
  integer, parameter :: nGC_4313 = 786
  integer, parameter :: nGC_4310 = 787
  integer, parameter :: nGC_4311 = 788
  integer, parameter :: nGC_4316 = 789
  integer, parameter :: nGC_4317 = 790
  integer, parameter :: nGC_4314 = 791
  integer, parameter :: nGC_4315 = 792
  integer, parameter :: nGC_7299 = 793
  integer, parameter :: nGC_7293 = 794
  integer, parameter :: nGC_7296 = 795
  integer, parameter :: nGC_4248 = 796
  integer, parameter :: nGC_7597 = 797
  integer, parameter :: nGC_7793 = 798
  integer, parameter :: nGC_7791 = 799
  integer, parameter :: nGC_4567 = 800
  integer, parameter :: nGC_7183 = 801
  integer, parameter :: nGC_4364 = 802
  integer, parameter :: nGC_4361 = 803
  integer, parameter :: nGC_7021 = 804
  integer, parameter :: nGC_313 = 805
  integer, parameter :: nGC_6466 = 806
  integer, parameter :: nGC_6461 = 807
  integer, parameter :: nGC_4481 = 808
  integer, parameter :: nGC_4262 = 809
  integer, parameter :: nGC_4261 = 810
  integer, parameter :: nGC_4464 = 811
  integer, parameter :: nGC_4465 = 812
  integer, parameter :: nGC_4503 = 813
  integer, parameter :: nGC_4500 = 814
  integer, parameter :: nGC_4506 = 815
  integer, parameter :: nGC_7700 = 816
  integer, parameter :: nGC_7701 = 817
  integer, parameter :: nGC_7179 = 818
  integer, parameter :: nGC_8055 = 819
  integer, parameter :: nGC_8054 = 820
  integer, parameter :: nGC_7272 = 821
  integer, parameter :: nGC_7273 = 822
  integer, parameter :: nGC_7177 = 823
  integer, parameter :: nGC_621 = 824
  integer, parameter :: nGC_4215 = 825
  integer, parameter :: nGC_4214 = 826
  integer, parameter :: nGC_4213 = 827
  integer, parameter :: nGC_4211 = 828
  integer, parameter :: nGC_6771 = 829
  integer, parameter :: nGC_6779 = 830
  integer, parameter :: nGC_7058 = 831
  integer, parameter :: nGC_7633 = 832
  integer, parameter :: nGC_6674 = 833
  integer, parameter :: nGC_6673 = 834
  integer, parameter :: nGC_8238 = 835
  integer, parameter :: nGC_11917 = 836
  integer, parameter :: nGC_11915 = 837
  integer, parameter :: nGC_7086 = 838
  integer, parameter :: nGC_4323 = 839
  integer, parameter :: nGC_4322 = 840
  integer, parameter :: nGC_4326 = 841
  integer, parameter :: nGC_4325 = 842
  integer, parameter :: nGC_4329 = 843
  integer, parameter :: nGC_4328 = 844
  integer, parameter :: nGC_6422 = 845
  integer, parameter :: nGC_10924 = 846
  integer, parameter :: nGC_10927 = 847
  integer, parameter :: nGC_10926 = 848
  integer, parameter :: nGC_10923 = 849
  integer, parameter :: nGC_6585 = 850
  integer, parameter :: nGC_6584 = 851
  integer, parameter :: nGC_6399 = 852
  integer, parameter :: nGC_6394 = 853
  integer, parameter :: nGC_6395 = 854
  integer, parameter :: nGC_6396 = 855
  integer, parameter :: nGC_4606 = 856
  integer, parameter :: nGC_6454 = 857
  integer, parameter :: nGC_6451 = 858
  integer, parameter :: nGC_6514 = 859
  integer, parameter :: nGC_6515 = 860
  integer, parameter :: nGC_7184 = 861
  integer, parameter :: nGC_7980 = 862
  integer, parameter :: nGC_7981 = 863
  integer, parameter :: nGC_283 = 864
  integer, parameter :: nGC_8939 = 865
  integer, parameter :: nGC_8936 = 866
  integer, parameter :: nGC_6632 = 867
  integer, parameter :: nGC_4551 = 868
  integer, parameter :: nGC_6635 = 869
  integer, parameter :: nGC_4252 = 870
  integer, parameter :: nGC_4251 = 871
  integer, parameter :: nGC_4257 = 872
  integer, parameter :: nGC_4255 = 873
  integer, parameter :: nGC_9309 = 874
  integer, parameter :: nGC_7188 = 875
  integer, parameter :: nGC_6758 = 876
  integer, parameter :: nGC_6746 = 877
  integer, parameter :: nGC_6742 = 878
  integer, parameter :: nGC_4308 = 879
  integer, parameter :: nGC_9112 = 880
  integer, parameter :: nGC_9111 = 881
  integer, parameter :: nGC_4307 = 882
  integer, parameter :: nGC_7784 = 883
  integer, parameter :: nGC_4330 = 884
  integer, parameter :: nGC_6555 = 885
  integer, parameter :: nGC_4374 = 886
  integer, parameter :: nGC_4377 = 887
  integer, parameter :: nGC_6414 = 888
  integer, parameter :: nGC_7059 = 889
  integer, parameter :: nGC_4518 = 890
  integer, parameter :: nGC_6524 = 891
  integer, parameter :: nGC_6520 = 892
  integer, parameter :: nGC_7087 = 893
  integer, parameter :: nGC_7281 = 894
  integer, parameter :: nGC_7083 = 895
  integer, parameter :: nGC_4583 = 896
  integer, parameter :: nGC_4581 = 897
  integer, parameter :: nGC_4585 = 898
  integer, parameter :: nGC_7249 = 899
  integer, parameter :: nGC_4589 = 900
  integer, parameter :: nGC_6706 = 901
  integer, parameter :: nGC_6708 = 902
  integer, parameter :: nGC_6668 = 903
  integer, parameter :: nGC_7607 = 904
  integer, parameter :: nGC_7608 = 905
  integer, parameter :: nGC_6666 = 906
  integer, parameter :: nGC_10158 = 907
  integer, parameter :: nGC_7678 = 908
  integer, parameter :: nGC_6926 = 909
  integer, parameter :: nGC_10159 = 910
  integer, parameter :: nGC_10168 = 911
  integer, parameter :: nGC_8956 = 912
  integer, parameter :: nGC_6575 = 913
  integer, parameter :: nGC_6545 = 914
  integer, parameter :: nGC_6987 = 915
  integer, parameter :: nGC_6546 = 916
  integer, parameter :: nGC_4236 = 917
  integer, parameter :: nGC_6556 = 918
  integer, parameter :: nGC_4238 = 919
  integer, parameter :: nGC_6464 = 920
  integer, parameter :: nGC_6988 = 921
  integer, parameter :: nGC_6613 = 922
  integer, parameter :: nGC_6505 = 923
  integer, parameter :: nGC_7634 = 924
  integer, parameter :: nGC_6370 = 925
  integer, parameter :: nGC_6371 = 926
  integer, parameter :: nGC_6691 = 927
  integer, parameter :: nGC_6413 = 928
  integer, parameter :: nGC_7063 = 929
  integer, parameter :: nGC_6692 = 930
  integer, parameter :: nGC_6402 = 931
  integer, parameter :: nGC_6465 = 932
  integer, parameter :: nGC_7005 = 933
  integer, parameter :: nGC_6565 = 934
  integer, parameter :: nGC_6944 = 935
  integer, parameter :: nGC_7006 = 936
  integer, parameter :: nGC_6686 = 937
  integer, parameter :: nGC_7481 = 938
  integer, parameter :: nGC_7189 = 939
  integer, parameter :: nGC_4331 = 940
  integer, parameter :: nGC_6595 = 941
  integer, parameter :: nGC_6591 = 942
  integer, parameter :: nGC_6547 = 943
  integer, parameter :: nGC_7116 = 944
  integer, parameter :: nGC_7792 = 945
  integer, parameter :: nGC_8940 = 946
  integer, parameter :: nGC_8213 = 947
  integer, parameter :: nGC_7298 = 948
  integer, parameter :: nGC_6642 = 949
  integer, parameter :: nGC_6625 = 950
  integer, parameter :: nGC_6626 = 951
  integer, parameter :: nGC_6376 = 952
  integer, parameter :: nGC_6842 = 953
  integer, parameter :: nGC_7699 = 954
  integer, parameter :: nGC_6748 = 955
  integer, parameter :: nGC_6643 = 956
  integer, parameter :: nGC_6471 = 957
  integer, parameter :: nGC_6579 = 958
  integer, parameter :: nGC_6473 = 959
  integer, parameter :: nGC_6472 = 960
  integer, parameter :: nGC_7151 = 961
  integer, parameter :: nGC_6531 = 962
  integer, parameter :: nGC_6532 = 963
  integer, parameter :: nGC_7880 = 964
  integer, parameter :: nGC_6747 = 965
  integer, parameter :: nGC_7190 = 966
  integer, parameter :: nGC_6476 = 967
  integer, parameter :: nGC_8252 = 968
  integer, parameter :: nGC_7761 = 969
  integer, parameter :: nGC_7110 = 970
  integer, parameter :: nGC_7277 = 971
  integer, parameter :: nGC_7115 = 972
  integer, parameter :: nGC_8056 = 973
  integer, parameter :: nGC_8396 = 974
  integer, parameter :: nGC_8397 = 975
  integer, parameter :: nGC_7255 = 976
  integer, parameter :: nGC_8246 = 977
  integer, parameter :: nGC_6430 = 978
  integer, parameter :: nGC_6596 = 979
  integer, parameter :: nGC_6614 = 980
  integer, parameter :: nGC_7111 = 981
  integer, parameter :: nGC_6927 = 982
  integer, parameter :: nGC_7762 = 983
  contains
  function get_coupling_value_mdl(c_id) result(ret_c)
    integer, intent(in) :: c_id
    complex(dp) :: ret_c
    if (c_id .eq. 0) then
      ret_c = cnul
    else
      ret_c = coupl(c_id)
    end if
  end function get_coupling_value_mdl
end module class_couplings
