!******************************************************************************!
!                                                                              !
!    class_ctparameters.f90                                                    !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   class_ctparameters.f90                         |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 05/2018                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2018-10-04 15:46             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module class_ctparameters
  use constants_mdl, only: dp
  implicit none
  logical :: complex_mass_scheme=.true.
  complex(dp) :: dMB_QCD2
  integer :: dMB_QCD2_scheme = 0
  complex(dp) :: dZgs_QCD2
  integer :: dZgs_QCD2_scheme = 1
  complex(dp) :: dZsL_QCD2
  integer :: dZsL_QCD2_scheme = 0
  complex(dp) :: dMS_QCD2
  integer :: dMS_QCD2_scheme = 0
  complex(dp) :: dZcR_QCD2
  integer :: dZcR_QCD2_scheme = 0
  complex(dp) :: dMD_QCD2
  integer :: dMD_QCD2_scheme = 0
  complex(dp) :: dZbR_QCD2
  integer :: dZbR_QCD2_scheme = 0
  complex(dp) :: dZdL_QCD2
  integer :: dZdL_QCD2_scheme = 0
  complex(dp) :: dZuR_QCD2
  integer :: dZuR_QCD2_scheme = 0
  complex(dp) :: dZg_QCD2
  integer :: dZg_QCD2_scheme = 0
  complex(dp) :: dZuL_QCD2
  integer :: dZuL_QCD2_scheme = 0
  complex(dp) :: dZtR_QCD2
  integer :: dZtR_QCD2_scheme = 0
  complex(dp) :: dZcL_QCD2
  integer :: dZcL_QCD2_scheme = 0
  complex(dp) :: dZbL_QCD2
  integer :: dZbL_QCD2_scheme = 0
  complex(dp) :: dMC_QCD2
  integer :: dMC_QCD2_scheme = 0
  complex(dp) :: dZsR_QCD2
  integer :: dZsR_QCD2_scheme = 0
  complex(dp) :: dMT_QCD2
  integer :: dMT_QCD2_scheme = 0
  complex(dp) :: dMU_QCD2
  integer :: dMU_QCD2_scheme = 0
  complex(dp) :: dZtL_QCD2
  integer :: dZtL_QCD2_scheme = 0
  complex(dp) :: dZdR_QCD2
  integer :: dZdR_QCD2_scheme = 0
  complex(dp) :: dZnu_muL
  complex(dp) :: dMWp2
  complex(dp) :: dZZ
  complex(dp) :: dMH2
  complex(dp) :: dZnu_muR
  complex(dp) :: dMZ2
  complex(dp) :: dZeMinusR
  complex(dp) :: dZmuMinusL
  complex(dp) :: dZtauMinusR
  complex(dp) :: dMW2
  complex(dp) :: dZnu_tauR
  complex(dp) :: dMTA
  complex(dp) :: dZtauMinusL
  complex(dp) :: dZA
  complex(dp) :: dZWMinus
  complex(dp) :: dZnu_eL
  complex(dp) :: dZeMinusL
  complex(dp) :: dMM
  complex(dp) :: dZWpMinus
  complex(dp) :: dME
  complex(dp) :: dZnu_eR
  complex(dp) :: dZnu_tauL
  complex(dp) :: dZH
  complex(dp) :: dZmuMinusR
! Derived counterterm parameters
  complex(dp) :: dytau_QED1
  complex(dp) :: dsw2_
  complex(dp) :: dmuH2_
  complex(dp) :: dlam_QED2
  complex(dp) :: dcw_
  complex(dp) :: dg1_QED1
  complex(dp) :: dgL_QED1
  complex(dp) :: dys_QED1_QCD2
  complex(dp) :: dys_QED1
  complex(dp) :: dgR_QED1
  complex(dp) :: dym_QED1
  complex(dp) :: dvev_QEDM1
  complex(dp) :: dgw_QED1
  complex(dp) :: dsw_
  complex(dp) :: dyt_QED1_QCD2
  complex(dp) :: dyt_QED1
  complex(dp) :: dye_QED1
  complex(dp) :: dydo_QED1
  complex(dp) :: dydo_QED1_QCD2
  complex(dp) :: dyup_QED1
  complex(dp) :: dyup_QED1_QCD2
  complex(dp) :: dyb_QED1_QCD2
  complex(dp) :: dyb_QED1
  complex(dp) :: dyc_QED1_QCD2
  complex(dp) :: dyc_QED1
  contains
  subroutine set_complex_mass_scheme_mdl

    ! This subroutine (re-)enables the complex mass scheme (hep-ph/0505042)

    complex_mass_scheme = .true.

  end subroutine set_complex_mass_scheme_mdl

  subroutine set_on_shell_scheme_mdl

    ! This subroutine disables the complex mass scheme

    complex_mass_scheme = .false.

  end subroutine set_on_shell_scheme_mdl
end module class_ctparameters
