!******************************************************************************!
!                                                                              !
!    fill_couplings1.f90                                                       !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   fill_couplings1.f90                            |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 05/2018                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2018-10-04 15:46             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module fill_couplings1
  use constants_mdl
  use class_couplings
  use class_ctparameters
  contains
    subroutine fill_couplings_mdl1()
      coupl(nGC_4532) = -sqrt(2d0)*CLq1x1*cima*ee*kL/(2d0*sw**2d0)
      coupl(nGC_4507) = -ee**2d0/(2d0*cw**2d0)
      coupl(nGC_4469) = sqrt(2d0)/2d0
      coupl(nGC_4505) = cima*ee*(cw**2d0 + sw**2d0)/(2d0*cw*sw**2d0)
      coupl(nGC_31) = sqrt(2d0)*CLl1x1*cima*ee*kL/(2d0*sw)
      coupl(nGC_4631) = cima*ee/cw
      coupl(nGC_4630) = -cima*ee*sw/cw**2d0
      coupl(nGC_4414) = sqrt(2d0)*sb/2d0
      coupl(nGC_4417) = sqrt(2d0)*sb/2d0
      coupl(nGC_4411) = cb*cima
      coupl(nGC_4384) = 2d0*cima*gs**2d0
      coupl(nGC_4380) = cMZ*cima*ee*(cw - sw)*(cw + sw)/(2d0*cw*sw**2d0)
      coupl(nGC_4382) = -gs
      coupl(nGC_4388) = cb*cima
      coupl(nGC_32) = sqrt(2d0)*CLl1x2*cima*ee*kL/(2d0*sw)
      coupl(nGC_35) = sqrt(2d0)*CLl2x2*cima*ee*kL/(2d0*sw)
      coupl(nGC_MZ_GF) = cMZ
      coupl(nGC_99) = -cima*ydo
      coupl(nGC_98) = -cima*sb*yc
      coupl(nGC_102) = -sqrt(2d0)*sb*ydo/2d0
      coupl(nGC_4560) = -sqrt(2d0)*CLq3x2*cima*ee*kL/(2d0*sw**2d0)
      coupl(nGC_28) = -cima*ee**2d0/(2d0*sw)
      coupl(nGC_29) = ee**2d0/(2d0*sw)
      coupl(nGC_4564) = -sqrt(2d0)*CLq3x3*cima*ee*kL/(2d0*sw**2d0)
      coupl(nGC_4566) = -sqrt(2d0)*CRq3x3*cima*ee*kR/(2d0*sw**2d0)
      coupl(nGC_23) = sqrt(2d0)*cima*ee/(2d0*sw)
      coupl(nGC_20) = -cima*ee/(2d0*sw)
      coupl(nGC_21) = cima*ee/(2d0*sw)
      coupl(nGC_26) = cima*cw*ee/sw
      coupl(nGC_27) = -ee**2d0/(2d0*sw)
      coupl(nGC_24) = sqrt(2d0)*cb*cima*ee/(2d0*sw)
      coupl(nGC_25) = -cima*cw*ee/sw
      coupl(nGC_34) = sqrt(2d0)*CLl2x1*cima*ee*kL/(2d0*sw)
      coupl(nGC_93) = -sqrt(2d0)*yb/2d0
      coupl(nGC_103) = -sqrt(2d0)*cima*sb*ydo/2d0
      coupl(nGC_14) = -cima*lam
      coupl(nGC_37) = sqrt(2d0)*CLl3x1*cima*ee*kL/(2d0*sw)
      coupl(nGC_4509) = cima*ee**2d0/(2d0*cw**2d0)
      coupl(nGC_82) = -cMW*cima*cw*ee/(2d0*sw) + cMW*cima*ee*sw/(2d0*cw)
      coupl(nGC_36) = sqrt(2d0)*CLl2x3*cima*ee*kL/(2d0*sw)
      coupl(nGC_80) = cima*cw*ee/(2d0*sw) + cima*ee*sw/(2d0*cw)
      coupl(nGC_126) = cima*sb*yup
      coupl(nGC_124) = sqrt(2d0)*yup/2d0
      coupl(nGC_125) = cb*cima*yup
      coupl(nGC_122) = -sqrt(2d0)*cima*ytau/2d0
      coupl(nGC_123) = -sqrt(2d0)*cima*yup/2d0
      coupl(nGC_120) = -cima*ytau
      coupl(nGC_121) = -sqrt(2d0)*ytau/2d0
      coupl(nGC_MMW_GF) = -cMW*cima
      coupl(nGC_75) = cima*ee*sw/cw
      coupl(nGC_74) = -2d0*cima*ee*sw/(3d0*cw)
      coupl(nGC_77) = -cima*cw*ee/(2d0*sw) - cima*ee*sw/(6d0*cw)
      coupl(nGC_76) = -cw*ee/(2d0*sw) - ee*sw/(2d0*cw)
      coupl(nGC_70) = cMZ*cima*ee/(2d0*sw)
      coupl(nGC_4558) = -sqrt(2d0)*CLq3x1*cima*ee*kL/(2d0*sw**2d0)
      coupl(nGC_73) = cima*ee*sw/(3d0*cw)
      coupl(nGC_71) = -sqrt(2d0)*cima*ee*sb/(2d0*sw)
      coupl(nGC_4349) = -3d0*cima*vev/2d0
      coupl(nGC_4348) = -3d0*cima*lam/2d0
      coupl(nGC_4340) = -3d0*cima/2d0
      coupl(nGC_4342) = -cima/2d0
      coupl(nGC_4345) = -cima*lam/2d0
      coupl(nGC_114) = -sqrt(2d0)*sb*ys/2d0
      coupl(nGC_4346) = -cima*vev/2d0
      coupl(nGC_4525) = cima*ee**2d0*(cw**2d0 + sw**2d0)**2d0/(2d0*cw**2d0*sw**&
                        2d0)
      coupl(nGC_4527) = -cima*ee**2d0*vev*(cw - sw)*(cw + sw)*(cw**2d0 + sw**  &
                        2d0)/(cw**2d0*sw**3d0)
      coupl(nGC_4526) = cima*ee**2d0*vev*(cw - sw)*(cw + sw)*(cw**2d0 + sw**2d0&
                        )/(cw**3d0*sw**2d0)
      coupl(nGC_4523) = -cima*ee**2d0*(cw - sw)*(cw + sw)*(cw**2d0 + sw**2d0)/(&
                        cw**2d0*sw**3d0)
      coupl(nGC_4522) = cima*ee**2d0*(cw - sw)*(cw + sw)*(cw**2d0 + sw**2d0)/( &
                        cw**3d0*sw**2d0)
      coupl(nGC_4449) = -sqrt(2d0)*cima/2d0
      coupl(nGC_4447) = -sqrt(2d0)/2d0
      coupl(nGC_4444) = -sqrt(2d0)*cima/2d0
      coupl(nGC_4442) = -sqrt(2d0)/2d0
      coupl(nGC_3) = -cima*ee
      coupl(nGC_2) = -2d0*cima*ee/3d0
      coupl(nGC_1) = cima*ee/3d0
      coupl(nGC_6) = 2d0*cima*ee**2d0
      coupl(nGC_5) = cima*ee**2d0
      coupl(nGC_4) = cima*ee
      coupl(nGC_9) = ee**2d0/(2d0*cw)
      coupl(nGC_8) = -cima*ee**2d0/(2d0*cw)
      coupl(nGC_4590) = -sqrt(2d0)*CLl2x3*cima*ee*kL/(2d0*sw**2d0)
      coupl(nGC_4592) = -sqrt(2d0)*CLl3x1*cima*ee*kL/(2d0*sw**2d0)
      coupl(nGC_4594) = -sqrt(2d0)*CRl3x1*cima*ee*kR/(2d0*sw**2d0)
      coupl(nGC_4596) = -sqrt(2d0)*CLl3x2*cima*ee*kL/(2d0*sw**2d0)
      coupl(nGC_4598) = -sqrt(2d0)*CRl3x2*cima*ee*kR/(2d0*sw**2d0)
      coupl(nGC_64) = sqrt(2d0)*CRq3x1*cima*ee*kR/(2d0*sw)
      coupl(nGC_16) = cMW*cima*ee
      coupl(nGC_4540) = -sqrt(2d0)*CLq1x3*cima*ee*kL/(2d0*sw**2d0)
      coupl(nGC_15) = -3d0*cima*lam/2d0
      coupl(nGC_1623) = -2d0*coupl(nGC_5)
      coupl(nGC_53) = sqrt(2d0)*CRl2x2*cima*ee*kR/(2d0*sw)
      coupl(nGC_52) = sqrt(2d0)*CRl2x1*cima*ee*kR/(2d0*sw)
      coupl(nGC_51) = sqrt(2d0)*CRl1x3*cima*ee*kR/(2d0*sw)
      coupl(nGC_50) = sqrt(2d0)*CRl1x2*cima*ee*kR/(2d0*sw)
      coupl(nGC_57) = sqrt(2d0)*CRl3x3*cima*ee*kR/(2d0*sw)
      coupl(nGC_56) = sqrt(2d0)*CRl3x2*cima*ee*kR/(2d0*sw)
      coupl(nGC_55) = sqrt(2d0)*CRl3x1*cima*ee*kR/(2d0*sw)
      coupl(nGC_54) = sqrt(2d0)*CRl2x3*cima*ee*kR/(2d0*sw)
      coupl(nGC_13) = -cima*lam/2d0
      coupl(nGC_59) = sqrt(2d0)*CRq1x2*cima*ee*kR/(2d0*sw)
      coupl(nGC_58) = sqrt(2d0)*CRq1x1*cima*ee*kR/(2d0*sw)
      coupl(nGC_46) = sqrt(2d0)*CLq3x1*cima*ee*kL/(2d0*sw)
      coupl(nGC_12) = cima*gs**2d0
      coupl(nGC_47) = sqrt(2d0)*CLq3x2*cima*ee*kL/(2d0*sw)
      coupl(nGC_11) = cima*gs
      coupl(nGC_101) = -sqrt(2d0)*cb*cima*ydo/2d0
      coupl(nGC_40) = sqrt(2d0)*CLq1x1*cima*ee*kL/(2d0*sw)
      coupl(nGC_10) = -gs
      coupl(nGC_41) = sqrt(2d0)*CLq1x2*cima*ee*kL/(2d0*sw)
      coupl(nGC_MC) = -cMC*cima
      coupl(nGC_2065) = -coupl(nGC_20)
      coupl(nGC_104) = sqrt(2d0)*sb*ydo/2d0
      coupl(nGC_49) = sqrt(2d0)*CRl1x1*cima*ee*kR/(2d0*sw)
      coupl(nGC_4520) = -cima*ee**2d0*(cw - sw)*(cw + sw)*(cw**2d0 + sw**2d0)/(&
                        cw**2d0*sw**3d0)
      coupl(nGC_4572) = -sqrt(2d0)*CRl1x2*cima*ee*kR/(2d0*sw**2d0)
      coupl(nGC_4628) = -cima*ee*(cw - sw)*(cw + sw)/(2d0*cw*sw**2d0)
      coupl(nGC_4622) = cima*ee*(3d0*cw**2d0 - sw**2d0)/(6d0*cw*sw**2d0)
      coupl(nGC_4621) = -cima*ee*(3d0*cw**2d0 - sw**2d0)/(6d0*cw**2d0*sw)
      coupl(nGC_4627) = cima*ee*(cw - sw)*(cw + sw)/(2d0*cw**2d0*sw)
      coupl(nGC_4624) = -cima*ee*sw/(3d0*cw**2d0)
      coupl(nGC_4625) = cima*ee/(3d0*cw)
      coupl(nGC_4403) = sqrt(2d0)*cima*sb/2d0
      coupl(nGC_4400) = -sqrt(2d0)*sb/2d0
      coupl(nGC_4406) = -sqrt(2d0)*cima*sb/2d0
      coupl(nGC_4529) = 2d0*cima*cw*ee**2d0/sw**2d0
      coupl(nGC_397) = -coupl(nGC_124)
      coupl(nGC_4391) = -sqrt(2d0)*cb/2d0
      coupl(nGC_4397) = -sqrt(2d0)*sb/2d0
      coupl(nGC_4394) = -sqrt(2d0)*cb*cima/2d0
      coupl(nGC_I) = cima
      coupl(nGC_4499) = cima*ee**2d0*(cw**2d0 + sw**2d0)/(cw*sw**2d0)
      coupl(nGC_4498) = -cima*ee**2d0*(cw**2d0 + sw**2d0)/(cw**2d0*sw)
      coupl(nGC_4496) = 2d0*cima*ee**2d0/sw**3d0
      coupl(nGC_4490) = -cima*ee**2d0/sw**3d0
      coupl(nGC_4493) = -cima*ee**2d0*vev/sw**3d0
      coupl(nGC_4492) = cima*ee**2d0/(2d0*sw**2d0)
      coupl(nGC_17) = cima*ee**2d0/(2d0*sw**2d0)
      coupl(nGC_19) = cima*cw**2d0*ee**2d0/sw**2d0
      coupl(nGC_18) = -cima*ee**2d0/sw**2d0
      coupl(nGC_4477) = cima*ee**2d0/(2d0*sw**2d0)
      coupl(nGC_4475) = -ee**2d0/(2d0*sw**2d0)
      coupl(nGC_4472) = -sqrt(2d0)*cima/2d0
      coupl(nGC_4578) = -sqrt(2d0)*CLl1x3*cima*ee*kL/(2d0*sw**2d0)
      coupl(nGC_4576) = -sqrt(2d0)*CRl1x3*cima*ee*kR/(2d0*sw**2d0)
      coupl(nGC_4574) = -sqrt(2d0)*CLl1x2*cima*ee*kL/(2d0*sw**2d0)
      coupl(nGC_4570) = -sqrt(2d0)*CRl1x1*cima*ee*kR/(2d0*sw**2d0)
      coupl(nGC_62) = sqrt(2d0)*CRq2x2*cima*ee*kR/(2d0*sw)
      coupl(nGC_415) = -coupl(nGC_4)
      coupl(nGC_637) = -coupl(nGC_93)
      coupl(nGC_631) = -2d0*coupl(nGC_19)
      coupl(nGC_MTA) = -cMTA*cima
      coupl(nGC_7) = -ee**2d0/(2d0*cw)
      coupl(nGC_95) = -sqrt(2d0)*cima*yc/2d0
      coupl(nGC_4454) = sqrt(2d0)/2d0
      coupl(nGC_4356) = -ee/(4d0*cMW*sw)
      coupl(nGC_4357) = cMW*ee/(2d0*sw**2d0)
      coupl(nGC_4354) = cima*ee/(2d0*cMW)
      coupl(nGC_4359) = -cima*ee/(4d0*cMW*sw)
      coupl(nGC_221) = -coupl(nGC_25)
      coupl(nGC_4613) = -sqrt(2d0)*cima*ee/(2d0*sw**2d0)
      coupl(nGC_4611) = sqrt(2d0)*cima*ee*sb/(2d0*sw**2d0)
      coupl(nGC_4616) = -2d0*cima*ee/(3d0*cw)
      coupl(nGC_4615) = 2d0*cima*ee*sw/(3d0*cw**2d0)
      coupl(nGC_4378) = -cMZ*cima*ee*(cw - sw)*(cw + sw)/(2d0*cw**2d0*sw)
      coupl(nGC_4619) = -cima*ee*(3d0*cw**2d0 + sw**2d0)/(6d0*cw*sw**2d0)
      coupl(nGC_4618) = cima*ee*(3d0*cw**2d0 + sw**2d0)/(6d0*cw**2d0*sw)
      coupl(nGC_4530) = -2d0*cima*cw**2d0*ee**2d0/sw**3d0
      coupl(nGC_4536) = -sqrt(2d0)*CRq1x2*cima*ee*kR/(2d0*sw**2d0)
      coupl(nGC_4534) = -sqrt(2d0)*CRq1x1*cima*ee*kR/(2d0*sw**2d0)
      coupl(nGC_4538) = -sqrt(2d0)*CLq1x2*cima*ee*kL/(2d0*sw**2d0)
      coupl(nGC_4439) = -sqrt(2d0)*cima/2d0
      coupl(nGC_4433) = -sqrt(2d0)*cima/2d0
      coupl(nGC_4430) = -sqrt(2d0)/2d0
      coupl(nGC_4437) = -sqrt(2d0)/2d0
      coupl(nGC_4370) = cima*cw*ee/sw**2d0
      coupl(nGC_359) = -coupl(nGC_12)
      coupl(nGC_4546) = -sqrt(2d0)*CLq2x1*cima*ee*kL/(2d0*sw**2d0)
      coupl(nGC_4544) = -sqrt(2d0)*CRq2x1*cima*ee*kR/(2d0*sw**2d0)
      coupl(nGC_4542) = -sqrt(2d0)*CRq1x3*cima*ee*kR/(2d0*sw**2d0)
      coupl(nGC_45) = sqrt(2d0)*CLq2x3*cima*ee*kL/(2d0*sw)
      coupl(nGC_42) = sqrt(2d0)*CLq1x3*cima*ee*kL/(2d0*sw)
      coupl(nGC_43) = sqrt(2d0)*CLq2x1*cima*ee*kL/(2d0*sw)
      coupl(nGC_4548) = -sqrt(2d0)*CRq2x2*cima*ee*kR/(2d0*sw**2d0)
      coupl(nGC_44) = sqrt(2d0)*CLq2x2*cima*ee*kL/(2d0*sw)
      coupl(nGC_4562) = -sqrt(2d0)*CRq3x2*cima*ee*kR/(2d0*sw**2d0)
      coupl(nGC_215) = -coupl(nGC_10)
      coupl(nGC_4369) = -cima*ee/sw
      coupl(nGC_4568) = -sqrt(2d0)*CLl1x1*cima*ee*kL/(2d0*sw**2d0)
      coupl(nGC_4367) = cMW*cima*ee*(cw**2d0 + sw**2d0)/(2d0*cw*sw**2d0)
      coupl(nGC_4366) = -cima*ee*(cw - sw)*(cw + sw)/(4d0*cMW*cw*sw)
      coupl(nGC_4365) = -cMW*cima*ee*(cw**2d0 + sw**2d0)/(2d0*cw**2d0*sw)
      coupl(nGC_4363) = -cima*cw*ee/sw**2d0
      coupl(nGC_4360) = cMW*cima*ee/(2d0*sw**2d0)
      coupl(nGC_4588) = -sqrt(2d0)*CRl2x3*cima*ee*kR/(2d0*sw**2d0)
      coupl(nGC_4488) = cima*ee/(2d0*sw**2d0)
      coupl(nGC_4482) = -ee/(2d0*sw**2d0)
      coupl(nGC_4480) = cima*ee**2d0*vev/(2d0*sw**2d0)
      coupl(nGC_4486) = ee**2d0/(2d0*sw**2d0)
    end subroutine fill_couplings_mdl1
end module fill_couplings1
