!******************************************************************************!
!                                                                              !
!    fill_couplings2.f90                                                       !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   fill_couplings2.f90                            |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 05/2018                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2018-10-04 15:46             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module fill_couplings2
  use constants_mdl
  use class_couplings
  use class_ctparameters
  contains
    subroutine fill_couplings_mdl2()
      coupl(nGC_4484) = -cima*ee/(2d0*sw**2d0)
      coupl(nGC_4466) = -sqrt(2d0)*cima/2d0
      coupl(nGC_4460) = -cima*sb
      coupl(nGC_4463) = sqrt(2d0)/2d0
      coupl(nGC_4501) = -ee*(cw - sw)*(cw + sw)/(2d0*cw**2d0*sw)
      coupl(nGC_4504) = -cima*ee*(cw**2d0 + sw**2d0)/(2d0*cw**2d0*sw)
      coupl(nGC_4479) = -cima*ee**2d0/(2d0*sw)
      coupl(nGC_4519) = cima*ee**2d0*(cw - sw)*(cw + sw)*(cw**2d0 + sw**2d0)/( &
                        cw**3d0*sw**2d0)
      coupl(nGC_593) = -coupl(nGC_21)
      coupl(nGC_97) = cb*cima*yc
      coupl(nGC_96) = sqrt(2d0)*yc/2d0
      coupl(nGC_94) = -sqrt(2d0)*cima*yb/2d0
      coupl(nGC_92) = -cima*yb
      coupl(nGC_91) = cima*cw**2d0*ee**2d0*vev/(2d0*sw**2d0) + cima*ee**2d0*vev&
                       + cima*ee**2d0*sw**2d0*vev/(2d0*cw**2d0)
      coupl(nGC_90) = -cima*ee**2d0*vev/(2d0*sw)
      coupl(nGC_79) = -cima*cw*ee/(2d0*sw) + cima*ee*sw/(2d0*cw)
      coupl(nGC_78) = cima*cw*ee/(2d0*sw) - cima*ee*sw/(6d0*cw)
      coupl(nGC_100) = -sqrt(2d0)*cb*ydo/2d0
      coupl(nGC_105) = -cima*ye
      coupl(nGC_106) = -sqrt(2d0)*ye/2d0
      coupl(nGC_107) = -sqrt(2d0)*cima*ye/2d0
      coupl(nGC_108) = -cima*ym
      coupl(nGC_109) = -sqrt(2d0)*ym/2d0
      coupl(nGC_22) = ee/(2d0*sw)
      coupl(nGC_60) = sqrt(2d0)*CRq1x3*cima*ee*kR/(2d0*sw)
      coupl(nGC_MWp) = cMWp**2d0*cima
      coupl(nGC_88) = -3d0*cima*lam*vev/2d0
      coupl(nGC_89) = cima*ee**2d0*vev/(2d0*sw**2d0)
      coupl(nGC_211) = -coupl(nGC_109)
      coupl(nGC_4600) = -sqrt(2d0)*CRl3x3*cima*ee*kR/(2d0*sw**2d0)
      coupl(nGC_4602) = -sqrt(2d0)*CLl3x3*cima*ee*kL/(2d0*sw**2d0)
      coupl(nGC_4607) = -sqrt(2d0)*cb*cima*ee/(2d0*sw**2d0)
      coupl(nGC_4609) = -sqrt(2d0)*cima*ee*sb/(2d0*sw**2d0)
      coupl(nGC_4586) = -sqrt(2d0)*CRl2x2*cima*ee*kR/(2d0*sw**2d0)
      coupl(nGC_929) = -coupl(nGC_79)
      coupl(nGC_4420) = -sqrt(2d0)*cb/2d0
      coupl(nGC_4423) = -sqrt(2d0)*cb*cima/2d0
      coupl(nGC_4502) = ee*(cw - sw)*(cw + sw)/(2d0*cw*sw**2d0)
      coupl(nGC_84) = cima*cw**2d0*ee**2d0/(2d0*sw**2d0) - cima*ee**2d0 + cima*&
                      ee**2d0*sw**2d0/(2d0*cw**2d0)
      coupl(nGC_361) = 2d0*coupl(nGC_12)
      coupl(nGC_39) = sqrt(2d0)*CLl3x3*cima*ee*kL/(2d0*sw)
      coupl(nGC_4556) = -sqrt(2d0)*CRq3x1*cima*ee*kR/(2d0*sw**2d0)
      coupl(nGC_4552) = -sqrt(2d0)*CLq2x3*cima*ee*kL/(2d0*sw**2d0)
      coupl(nGC_4362) = cima*ee/sw
      coupl(nGC_MT) = -cMT*cima
      coupl(nGC_66) = sqrt(2d0)*CRq3x3*cima*ee*kR/(2d0*sw)
      coupl(nGC_65) = sqrt(2d0)*CRq3x2*cima*ee*kR/(2d0*sw)
      coupl(nGC_72) = sqrt(2d0)*cima*ee*sb/(2d0*sw)
      coupl(nGC_MI) = -cima
      coupl(nGC_MH) = -cMH**2d0*cima
      coupl(nGC_MM) = -cMM*cima
      coupl(nGC_869) = -coupl(nGC_76)
      coupl(nGC_MB) = -cMB*cima
      coupl(nGC_61) = sqrt(2d0)*CRq2x1*cima*ee*kR/(2d0*sw)
      coupl(nGC_ME) = -cME*cima
      coupl(nGC_MD) = -cMD*cima
      coupl(nGC_MZ) = cMZ**2d0*cima
      coupl(nGC_MS) = -cMS*cima
      coupl(nGC_MW) = cMW**2d0*cima
      coupl(nGC_MU) = -cMU*cima
      coupl(nGC_48) = sqrt(2d0)*CLq3x3*cima*ee*kL/(2d0*sw)
      coupl(nGC_63) = sqrt(2d0)*CRq2x3*cima*ee*kR/(2d0*sw)
      coupl(nGC_MW_GF) = cMW*cima
      coupl(nGC_4379) = -cima*ee*(cw**2d0 + sw**2d0)/(4d0*cMZ*cw*sw)
      coupl(nGC_4375) = cima*ee/(4d0*cMZ*sw)
      coupl(nGC_4376) = -cMZ*cima*ee/(2d0*sw**2d0)
      coupl(nGC_4372) = ee/(4d0*cMW*sw)
      coupl(nGC_4373) = -cMW*ee/(2d0*sw**2d0)
      coupl(nGC_4554) = -sqrt(2d0)*CRq2x3*cima*ee*kR/(2d0*sw**2d0)
      coupl(nGC_243) = -coupl(nGC_26)
      coupl(nGC_38) = sqrt(2d0)*CLl3x2*cima*ee*kL/(2d0*sw)
      coupl(nGC_4550) = -sqrt(2d0)*CLq2x2*cima*ee*kL/(2d0*sw**2d0)
      coupl(nGC_4451) = cima*sb
      coupl(nGC_4457) = -sqrt(2d0)*cima/2d0
      coupl(nGC_30) = 2d0*cima*cw*ee**2d0/sw
      coupl(nGC_4511) = -cima*ee**2d0/(2d0*cw)
      coupl(nGC_4512) = cima*ee**2d0*vev/(2d0*cw**2d0)
      coupl(nGC_4514) = ee**2d0/(2d0*cw**2d0)
      coupl(nGC_33) = sqrt(2d0)*CLl1x3*cima*ee*kL/(2d0*sw)
      coupl(nGC_4516) = 2d0*cima*ee**2d0/sw
      coupl(nGC_4517) = -2d0*cima*cw*ee**2d0/sw**2d0
      coupl(nGC_4582) = -sqrt(2d0)*CLl2x1*cima*ee*kL/(2d0*sw**2d0)
      coupl(nGC_4580) = -sqrt(2d0)*CRl2x1*cima*ee*kR/(2d0*sw**2d0)
      coupl(nGC_4584) = -sqrt(2d0)*CLl2x2*cima*ee*kL/(2d0*sw**2d0)
      coupl(nGC_81) = -cima*cw*ee**2d0/sw + cima*ee**2d0*sw/cw
      coupl(nGC_83) = -cMZ*cima*cw*ee/(2d0*sw) - cMZ*cima*ee*sw/(2d0*cw)
      coupl(nGC_85) = cima*cw**2d0*ee**2d0/(2d0*sw**2d0) + cima*ee**2d0 + cima*&
                      ee**2d0*sw**2d0/(2d0*cw**2d0)
      coupl(nGC_86) = -cima*ee**2d0*vev/(2d0*cw)
      coupl(nGC_87) = -cima*lam*vev/2d0
      coupl(nGC_145) = cima*gs
      coupl(nGC_67) = -cMW*ee/(2d0*sw)
      coupl(nGC_68) = -cMW*cima*ee/(2d0*sw)
      coupl(nGC_69) = cMW*ee/(2d0*sw)
      coupl(nGC_119) = sqrt(2d0)*yt/2d0
      coupl(nGC_118) = -sqrt(2d0)*cima*yt/2d0
      coupl(nGC_117) = cima*yt
      coupl(nGC_116) = sqrt(2d0)*sb*ys/2d0
      coupl(nGC_115) = sqrt(2d0)*cima*sb*ys/2d0
      coupl(nGC_113) = -sqrt(2d0)*cb*cima*ys/2d0
      coupl(nGC_112) = -sqrt(2d0)*cb*ys/2d0
      coupl(nGC_111) = -cima*ys
      coupl(nGC_110) = -sqrt(2d0)*cima*ym/2d0
      coupl(nGC_381) = -coupl(nGC_3)
      coupl(nGC_371) = -2d0*coupl(nGC_12)
      coupl(nGC_791) = -2d0*coupl(nGC_18)
      coupl(nGC_305) = -coupl(nGC_22)
      coupl(nGC_567) = -coupl(nGC_100)
      coupl(nGC_513) = -coupl(nGC_96)
      coupl(nGC_2241) = -coupl(nGC_119)
      coupl(nGC_1255) = -coupl(nGC_112)
      coupl(nGC_313) = -coupl(nGC_106)
      coupl(nGC_621) = -coupl(nGC_121)
      coupl(nGC_283) = -coupl(nGC_30)/2d0
    end subroutine fill_couplings_mdl2
end module fill_couplings2
