!******************************************************************************!
!                                                                              !
!    lcFVFa.f90                                                                !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   lcFVFa.f90                                     |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 05/2018                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2018-10-04 15:46             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module lcFVFa
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec
  contains
    subroutine loopFVFa(ty, co, wl, P1, PL1, w2, P2, PL2, m, wp, riMaxIn,      &
    riMaxOut, rankInc)
      integer, intent(in) :: riMaxIn, riMaxOut, rankInc
      complex (kind = dp), intent(in), dimension(0:3) :: P1, PL1
      complex (kind = dp), intent(in), dimension(0:3, 0:riMaxIn) :: wl
      complex (kind = dp), intent(in), dimension(0:3) :: P2, PL2
      complex (kind = dp), intent(in), dimension(0:3) :: w2
      complex (dp), intent(out), dimension(0:3,0:riMaxOut) :: wp
      complex (kind = dp), intent(in) :: m
      complex (kind = dp), dimension(0:3) :: pl, p
      integer, intent(in) :: ty
      complex (kind = dp), dimension(0:), intent(in) :: co
      complex (kind = dp), dimension(0:3) :: sp1
      complex (kind = dp), dimension(0:3,0:3) :: sp2
      complex (kind = dp), dimension(0:3,0:3,0:3) :: sp3
      complex (kind = dp), dimension(0:3,0:3,0:3,0:3) :: sp4
      character(len=3) :: ty_str
      integer :: riOut, j
      logical :: isFirstRI
      integer :: mu, nu, ro, ta, te, tu
      select case(ty)
      case(FVFa0)
!       GammaP(2,3,1)*c0
!       GammaM(2,3,1)*c1
        pl(:) = PL1(:) + PL2(:)
        x0 = cima*w2(0)
        x1 = pl(0)*x0
        x2 = cima*w2(3)
        x3 = pl(0)*x2
        x4 = cima*w2(1)
        x5 = pl(3)*w2(2) - pl(3)*x4
        x7 = pl(0)*w2(2)
        x8 = pl(0)*x4
        x9 = -pl(3)*x0
        x10 = pl(3)*x2
        x12 = w2(2) + x4
        x14 = co(1)*m
        x15 = w2(0) + w2(3)
        x18 = pl(2)*w2(2)
        x19 = pl(2)*x4
        x20 = pl(1)*x0 + pl(1)*x2
        x21 = pl(1)*w2(2)
        x22 = pl(1)*x4
        x23 = cima*pl(2)
        x24 = w2(3)*x23
        x25 = w2(0)*x23
        x26 = -w2(2) + x4
        x28 = w2(0) - w2(3)
        x34 = co(0)*m
        x45 = cima*w2(2)
        x46 = w2(1) + x45
        x47 = -w2(1) + x45
        do j = riMaxIn, 0, -1
          x6 = co(0)*wl(0,j)
          x11 = co(0)*wl(1,j)
          x13 = wl(3,j)*x12
          x16 = wl(2,j)*x15
          x17 = cima*x16
          x27 = wl(2,j)*x26
          x29 = wl(3,j)*x28
          x30 = cima*x29
          x31 = co(1)*wl(2,j)
          x32 = co(1)*wl(3,j)
          x33 = wl(1,j)*x12
          x35 = wl(0,j)*x28
          x36 = cima*x35
          x37 = wl(0,j)*x26
          x38 = wl(1,j)*x15
          x39 = cima*x38
          x40 = co(0)*(-x33 + x36)
          x41 = co(0)*(-x37 + x39)
          x42 = co(1)*(x13 + x17)
          x43 = co(1)*(x27 + x30)
          x44 = -x40
          wp(0,j) = -x11*(-x10 + x7 + x8 + x9) - x13*x14 - x14*x17 + x6*(x1 -  &
                    x3 + x5)
          wp(1,j) = x11*(-x18 - x19 + x20) - x14*x27 - x14*x30 - x6*(-x21 + x22&
                     + x24 - x25)
          wp(2,j) = x31*(x20 + x5) + x32*(x10 + x21 + x22 + x9) + x33*x34 - x34&
                    *x36
          wp(3,j) = -x31*(x24 + x25 + x7 - x8) - x32*(-x1 + x18 + x19 + x3) +  &
                    x34*x37 - x34*x39
          if(rankInc .lt. 1) cycle
          sp2(0,0) = x40
          sp2(0,1) = x41
          sp2(0,2) = x42
          sp2(0,3) = x43
          sp2(1,0) = -x41
          sp2(1,1) = x44
          sp2(1,2) = x43
          sp2(1,3) = x42
          sp2(2,0) = co(0)*wl(0,j)*x46 - co(0)*x38
          sp2(2,1) = co(0)*wl(1,j)*x47 + co(0)*x35
          sp2(2,2) = co(1)*wl(2,j)*x46 + co(1)*x29
          sp2(2,3) = co(1)*wl(3,j)*x47 - co(1)*x16
          sp2(3,0) = x44
          sp2(3,1) = x41
          sp2(3,2) = x42
          sp2(3,3) = -x43
          do mu = 0, 3
            riOut = incRI(mu, j)
            wp(:,riOut) = wp(:,riOut) + sp2(mu,:)
          end do 
        end do 
      case(FVFa1)
!       GammaM(2,3,1)*c0
        pl(:) = PL1(:) + PL2(:)
        x0 = cima*w2(1)
        x5 = cima*w2(0)
        x6 = cima*w2(3)
        x7 = cima*w2(2)
        do j = riMaxIn, 0, -1
          x1 = wl(2,j)*(w2(0) + w2(3))
          x2 = co(0)*(cima*x1 + wl(3,j)*(w2(2) + x0))
          x3 = wl(3,j)*(w2(0) - w2(3))
          x4 = co(0)*(cima*x3 + wl(2,j)*(-w2(2) + x0))
          wp(0,j) = -m*x2
          wp(1,j) = -m*x4
          wp(2,j) = co(0)*(wl(2,j)*(pl(1)*x5 + pl(1)*x6 + pl(3)*w2(2) - pl(3)* &
                    x0) + wl(3,j)*(pl(1)*w2(2) + pl(1)*x0 - pl(3)*x5 + pl(3)*x6&
                    ))
          wp(3,j) = -co(0)*(wl(2,j)*(pl(0)*w2(2) - pl(0)*x0 + pl(2)*x5 + pl(2)*&
                    x6) + wl(3,j)*(-pl(0)*x5 + pl(0)*x6 + pl(2)*w2(2) + pl(2)* &
                    x0))
          if(rankInc .lt. 1) cycle
          sp2(0,0) = 0
          sp2(0,1) = 0
          sp2(0,2) = x2
          sp2(0,3) = x4
          sp2(1,0) = 0
          sp2(1,1) = 0
          sp2(1,2) = x4
          sp2(1,3) = x2
          sp2(2,0) = 0
          sp2(2,1) = 0
          sp2(2,2) = co(0)*w2(1)*wl(2,j) + co(0)*wl(2,j)*x7 + co(0)*x3
          sp2(2,3) = -co(0)*w2(1)*wl(3,j) + co(0)*wl(3,j)*x7 - co(0)*x1
          sp2(3,0) = 0
          sp2(3,1) = 0
          sp2(3,2) = x2
          sp2(3,3) = -x4
          do mu = 0, 3
            riOut = incRI(mu, j)
            wp(:,riOut) = wp(:,riOut) + sp2(mu,:)
          end do 
        end do 
      end select 
    end subroutine loopFVFa
end module lcFVFa
